

/****** Object : Table [dbo].[ServiceTemp] Copyright TECK SYSTEM SOFT 2015 ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ServiceTemp] SET [Customer] = '' WHERE [Customer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ServiceTemp] SET [Site] = '' WHERE [Site] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ServiceTemp] SET [Manager] = '' WHERE [Manager] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ServiceTemp] SET [Severity] = '' WHERE [Severity] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ServiceTemp] SET [Dashboard] = '' WHERE [Dashboard] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ServiceTemp] SET [Domain] = '' WHERE [Domain] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ServiceTemp] SET [Computer] = '' WHERE [Computer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ServiceTemp] SET [Service] = '' WHERE [Service] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ServiceTemp] SET [Status] = '' WHERE [Status] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ServiceTemp] SET [Mode] = '' WHERE [Mode] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ServiceTemp] SET [Alarm] = '' WHERE [Alarm] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ServiceTemp] SET [Closed] = '' WHERE [Closed] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[ServiceTemp] SET [Availability] = '' WHERE [Availability] IS NULL

 INSERT INTO [Monitorpack_GuardReportsMonitorpack].[dbo].[Service]
([Insert_Date]
       ,[Customer]
       ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[Service]
      ,[Status] 
      ,[Mode] 
      ,[Alarm]
      ,[Closed]
	  ,[Availability]
)

SELECT  
GETDATE()-1
       ,[Customer]
       ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain] 
      ,[Computer]
      ,[Service]
      ,[Status] 
      ,[Mode] 
      ,[Alarm]
      ,[Closed]
	  ,CONVERT(nvarchar(10),[Availability])
	  
FROM

/****** Added 08 spetember 2020 ******/
/* (SELECT DISTINCT [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Service] +  '-' + [Status] + '-' + [Alarm] + '-' + CONVERT(nvarchar(10),[Availability])  AS SEARCH_STRING */
(SELECT DISTINCT [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Service] +  '-' + [Status] + '-' + [Alarm] + '-' + [Closed] + '-' + CONVERT(nvarchar(10),[Availability])  AS SEARCH_STRING	 

  /*,[Insert_Date] Add for test purpose only */
       ,[Customer]
       ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[Service]
      ,[Status] 
      ,[Mode]
      ,[Alarm]
      ,[Closed]
      ,[Availability] 

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[ServiceTemp]
WHERE [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Service] +  '-' + [Status] + '-' + [Alarm] + '-' + [Closed] + '-' + CONVERT(nvarchar(10),[Availability]) NOT IN 

(SELECT DISTINCT [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Service] +  '-' + [Status] + '-' + [Alarm]  + '-' + CONVERT(nvarchar(10),[Closed]) + '-' + CONVERT(nvarchar(10),[Availability]) AS SEARCH_STRING
FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[Service]) ) TBL 

/****** Object : UPDATE existing entries with the lastest values ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[Service] 
SET  
[Service] = REQUEST.[Service],
[Status] = REQUEST.[Status],
[Alarm] = REQUEST.[Alarm],
[Closed] = REQUEST.[Closed],
[Availability] = REQUEST.[Availability],
[Insert_Date] = REQUEST.[Insert_Date] -- Last UPDATE time

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[Service] SERVS,

/****** Object : Select values ******/

(SELECT TEMP_JOIN.[Service_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[Service],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Status],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Closed],
TEMP_JOIN.[Availability]

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[ServiceTemp] TEMP
INNER JOIN  [Monitorpack_GuardReportsMonitorpack].[dbo].[ServiceTemp] TEMP_JOIN 
ON TEMP_JOIN.[Mode] = TEMP.[Mode]

WHERE 
TEMP.[Customer] = TEMP_JOIN .[Customer] AND
TEMP.[Site] = TEMP_JOIN .[Site] AND
TEMP.[Domain] = TEMP_JOIN .[Domain] AND
TEMP.[Computer] = TEMP_JOIN .[Computer] AND
TEMP.[Service] =  TEMP_JOIN .[Service] AND
TEMP.[Mode] = TEMP_JOIN .[Mode] AND
TEMP.[Status] = TEMP_JOIN .[Status]AND
TEMP.[Alarm] = TEMP_JOIN .[Alarm] AND
TEMP.[Alarm] = TEMP_JOIN .[Closed] AND

TEMP.[Availability]=TEMP_JOIN.[Availability]
GROUP BY
TEMP_JOIN.[Service_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[Service],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Status],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Closed],
TEMP_JOIN.[Availability]

HAVING max(TEMP.Service_ID) = TEMP_JOIN.[Service_ID]) AS REQUEST

WHERE
SERVS.[Customer] = REQUEST.[Customer]
AND SERVS.[Site] = REQUEST.[Site]
AND SERVS.[Domain] = REQUEST.[Domain]
AND SERVS.[Computer] = REQUEST.[Computer]
AND SERVS.[Alarm] = REQUEST.[Alarm]
AND SERVS.[Service] = REQUEST.[Service]
AND SERVS.[Status] = REQUEST.[Status]
AND SERVS.[Closed] = REQUEST.[Closed]
AND SERVS.Availability = REQUEST.Availability
   

/****** Object : Clean Temporary SQL Table ******/

/* TRUNCATE TABLE [Monitorpack_GuardReportsMonitorpack].[dbo].[ServiceTemp] */
